// cgD3D_ab.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "cgD3D_ab.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

CGD3D_AB_API const char * CGD3D_API cgProgramContainer_GetVertexDeclaration(void *self)
{
	return ((cgProgramContainer*)self)->GetVertexDeclaration();
}
    

CGD3D_AB_API HRESULT CGD3D_API cgProgramContainer_SetShaderConstantD3DXMATRIX(void *self, cgBindIter * iter, const D3DXMATRIX *m, int nArrayElements, int ArrayOffset)
{
	return ((cgProgramContainer*)self)->SetShaderConstantD3DXMATRIX(iter, m, nArrayElements, ArrayOffset);
}


CGD3D_AB_API HRESULT CGD3D_API cgProgramContainer_SetShaderConstant(void *self, cgBindIter * iter, void * data, int nArrayElements, int ArrayOffset)
{
	return ((cgProgramContainer*)self)->SetShaderConstant(iter, data, nArrayElements, ArrayOffset);
}


CGD3D_AB_API int CGD3D_API cgProgramContainer_GetTexturePosition(void *self, cgBindIter * BindIter)
{
	return ((cgProgramContainer*)self)->GetTexturePosition(BindIter);
}

CGD3D_AB_API int CGD3D_API cgProgramContainer_GetTexturePositionB(void *self, const char * name)
{
	return ((cgProgramContainer*)self)->GetTexturePosition(name);
}

CGD3D_AB_API HRESULT CGD3D_API cgProgramContainer_SetTexture(void *self, const char * name, LPDIRECT3DBASETEXTURE8 pTexture)
{
	return ((cgProgramContainer*)self)->SetTexture(name, pTexture);
}

CGD3D_AB_API HRESULT CGD3D_API cgProgramContainer_SetTextureB(void *self, cgBindIter * BindIter, LPDIRECT3DBASETEXTURE8 pTexture)
{
	return ((cgProgramContainer*)self)->SetTexture(BindIter, pTexture);
}

CGD3D_AB_API HRESULT CGD3D_API cgProgramContainer_SetTextureStageState(void *self, cgBindIter * BindIter, D3DTEXTURESTAGESTATETYPE Type,DWORD Value)
{
	return ((cgProgramContainer*)self)->SetTextureStageState(BindIter, Type, Value);
}

CGD3D_AB_API HRESULT CGD3D_API cgProgramContainer_SetTextureWrapMode(void *self, cgBindIter * BindIter, DWORD WrapCoords)
{
	return ((cgProgramContainer*)self)->SetTextureWrapMode(BindIter, WrapCoords);
}


CGD3D_AB_API HRESULT CGD3D_API cgProgramContainer_SetShaderActive(void *self)
{
	return ((cgProgramContainer*)self)->SetShaderActive();
}

CGD3D_AB_API cgBindIter *CGD3D_API cgProgramContainer_GetVertexBindByName(void *self, const char *vertex_attr_name)
{
	return ((cgProgramContainer*)self)->GetVertexBindByName(vertex_attr_name);
}

CGD3D_AB_API cgBindIter *CGD3D_API cgProgramContainer_GetTextureBindByName(void *self, const char *texture_name)
{
	return ((cgProgramContainer*)self)->GetTextureBindByName(texture_name);
}

CGD3D_AB_API cgBindIter *CGD3D_API cgProgramContainer_GetParameterBindByName(void *self, const char *parameter_name)
{
	return ((cgProgramContainer*)self)->GetParameterBindByName(parameter_name);
}
    
CGD3D_AB_API void CGD3D_API cgProgramContainer_FreeBindIter(void *self, cgBindIter *c)
{
	((cgProgramContainer*)self)->FreeBindIter(c);
}


CGD3D_AB_API cgBindIter *CGD3D_API cgProgramContainer_GetBindByFullName(void *self, const char *parameter_name)
{
	return ((cgProgramContainer*)self)->GetBindByFullName(parameter_name);
}

CGD3D_AB_API const char *CGD3D_API cgProgramContainer_GetProgramName(void *self)
{
//todo: Fix this later
//	return ((cgProgramContainer*)self)->GetProgramName();
//	return cgGetProgramName( ((cgProgramContainer*)self)->m_ProgramIter )
	return NULL;
}
    
CGD3D_AB_API const char * CGD3D_API cgProgramContainer_GetProgramObjectCode(void *self)
{
	return ((cgProgramContainer*)self)->GetProgramObjectCode();
}

CGD3D_AB_API cgProfileType CGD3D_API cgProgramContainer_GetProgramProfile(void *self) // { return m_ProfileType;}
{
	return ((cgProgramContainer*)self)->GetProgramProfile();
}

CGD3D_AB_API DWORD CGD3D_API cgProgramContainer_GetShaderHandle(void *self) // {return m_dwShaderHandle;}  
{
	return ((cgProgramContainer*)self)->GetShaderHandle();
}


/*
    cgProgramContainer(LPDIRECT3DDEVICE8 pDev, cgProgramIter *m_ProgramIter,
						cgProfileType ProfileType);
    ~cgProgramContainer();
*/

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

CGD3D_AB_API cgDirect3D * CGD3D_API cgDirect3D_Create()
{
	return new cgDirect3D;
}

CGD3D_AB_API void CGD3D_API cgDirect3D_Destroy(cgDirect3D * cg)
{
	delete cg;
}

CGD3D_AB_API void CGD3D_API cgDirect3D_AddFilePath(void *self, const char * dirpath)
{
	((cgDirect3D*)self)->AddFilePath(dirpath);
}

CGD3D_AB_API void CGD3D_API cgDirect3D_NotePad(void *self, const char * title, const char * listing )
{
	((cgDirect3D*)self)->NotePad(title, listing);
}

CGD3D_AB_API cgContextContainer * CGD3D_API cgDirect3D_CreateContextContainer(void *self, LPDIRECT3DDEVICE8 pd3dDevice, DWORD * outIndex)
{
	return ((cgDirect3D*)self)->CreateContextContainer(pd3dDevice, outIndex);
}



////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////


CGD3D_AB_API const char *CGD3D_API cgContextContainer_GetLastListing(void *self)
{
	return ((cgContextContainer*)self)->GetLastListing();
}


CGD3D_AB_API cgProgramContainer * CGD3D_API cgContextContainer_LoadCGProgramFromFile(void *self, 
        const char * filename,           // filename of the Cg program
        const char * title,               // title of the program                               
        cgProfileType type,       // profile of the program                            
        cgVertexDefinition * va, // optionally, set streams or allow different vetex definitions
        DWORD * outIndex,
        const char * entry)
{
	return ((cgContextContainer*)self)->LoadCGProgramFromFile(
        filename,           // filename of the Cg program
        title,               // title of the program                               
        type,       // profile of the program                            
        va, // optionally, set streams or allow different vetex definitions
        outIndex,
        entry);
}

CGD3D_AB_API cgProgramContainer *  CGD3D_API cgContextContainer_LoadCGProgramFromMemory(void *self, 
        const char * memory,          // memory location that contain the cg program 
        const char * title,            // name of the program 
        cgProfileType type,    // profile of the program
        cgVertexDefinition * va,   // optionally, set the streams for each vertex entry
        DWORD * outIndex,
        const char * entry)
{
	return ((cgContextContainer*)self)->LoadCGProgramFromMemory(
        memory,          // memory location that contain the cg program 
        title,            // name of the program 
        type,    // profile of the program
        va,   // optionally, set the streams for each vertex entry
        outIndex,
        entry);
}


CGD3D_AB_API cgProgramContainer * CGD3D_API cgContextContainer_GetProgramIterator(void *self, DWORD index)
{
	return ((cgContextContainer*)self)->GetProgramIterator(index);
}


CGD3D_AB_API cgProgramIter *CGD3D_API cgContextContainer_GetNextProgram(void *self, cgProgramIter *iter)
{
	return ((cgContextContainer*)self)->GetNextProgram(iter);
}

CGD3D_AB_API cgProgramIter *CGD3D_API cgContextContainer_ProgramByName(void *self, const char *name)
{
	return ((cgContextContainer*)self)->ProgramByName(name);
}


CGD3D_AB_API DWORD CGD3D_API cgContextContainer_GetShaderHandle(void *self, cgProfileType type)
{
	return ((cgContextContainer*)self)->GetShaderHandle(type);
}

CGD3D_AB_API void CGD3D_API cgContextContainer_Destroy(cgContextContainer * c)
{
	delete c;
}

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////


/*	cgProgramManager(LPDIRECT3DDEVICE8 pDev);
	~cgProgramManager(); */
/*

CGD3D_AB_API HRESULT cgProgramManager_Free(void *self)
{
	return ((cgProgramManager*)self)->Free();
}


CGD3D_AB_API cgProgramContainer * cgProgramManager_CreateProgramContainer(void *self, LPDIRECT3DDEVICE8 pDev,
        cgProgramIter * ProgramIter,
        DWORD Usage,
        cgProfileType ProfileType,
        DWORD * outIndex )
{
	return ((cgProgramManager*)self)->CreateProgramContainer(pDev,
        ProgramIter,
        Usage,
        ProfileType,
        outIndex );
}


CGD3D_AB_API DWORD	cgProgramManager_GetShaderHandle( void *self, DWORD Index )
{
	return ((cgProgramManager*)self)->GetShaderHandle( Index );
}

CGD3D_AB_API DWORD	cgProgramManager_GetShaderHandle( void *self, cgProfileType ProfileType )
{
	return ((cgProgramManager*)self)->GetShaderHandle(ProfileType );
}

CGD3D_AB_API cgProgramContainer * cgProgramManager_GetProgramIterator(void *self, DWORD index)
{
	return ((cgProgramManager*)self)->GetProgramIterator(index);
}
*/